Difference between revisions of "Part Module/fr"

From FreeCAD Documentation
Jump to navigation Jump to search
(Created page with "Un autre objet simple utilisé dans les objets géométriques 2D est Part Part2DObject, qui constitue la base des esquisses...")
 
(81 intermediate revisions by 6 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
{{docnav/fr|[[OpenSCAD Module/fr|Atelier OpenSCAD]]|[[PartDesign Workbench/fr|Atelier PartDesign]]|IconL=OpenSCADWorkbench.svg|IconR=Workbench_PartDesign.svg}}
+
{{Docnav/fr
 
+
|[[OpenSCAD Module/fr|Module OpenSCAD]]
[[Image:Workbench_Part.svg|64px]]
+
|[[PartDesign Workbench/fr|Atelier PartDesign]]
 +
|IconL=Workbench_OpenSCAD.svg
 +
|IconR=Workbench_PartDesign.svg
 +
}}
  
 +
[[Image:Workbench_Part.svg|thumb|128px|Icône de l'Atelier Part]]
 +
{{TOCright}}
 
== Introduction ==
 
== Introduction ==
Les capacités de modélisations de solides de FreeCAD sont basées sur le noyau [http://en.wikipedia.org/wiki/Open_Cascade_Technology Open Cascade Technology] (OCCT) , un système de CAO de niveau professionnel qui offre une création et une manipulation avancées de la géométrie 3D. L'[[Part Workbench/fr|atelier Part]] est une couche située au-dessus des bibliothèques OCCT, qui permet à l'utilisateur d'accéder aux primitives et fonctions géométriques OCCT. Toutes les fonctions de dessin 2D et 3D de chaque atelier ([[Draft Workbench/fr|Draft]], [Sketcher Workbench/fr|Sketcher], [[PartDesign Workbench/fr|PartDesign]], etc.), sont basées sur ces fonctions exposées par l'atelier Part. Par conséquent, L'atelier Part est considéré comme le composant central des capacités de modélisation de FreeCAD.
+
Les capacités de modélisations de solides de FreeCAD sont basées sur le noyau [[OpenCASCADE|OpenCASCADE Technology]] (OCCT), un système de CAO de niveau professionnel qui offre une création et une manipulation avancées de la géométrie 3D. L'[[Image:Workbench_Part.svg|24px]] [[Part Workbench/fr|atelier Part]] est une couche située au-dessus des bibliothèques OCCT qui permet à l'utilisateur d'accéder aux primitives et fonctions géométriques OCCT. Toutes les fonctions de dessin 2D et 3D de chaque atelier ([[Image:Workbench_Draft.svg|24px]] [[Draft Workbench/fr|Draft]], [[Image:Workbench_Sketcher.svg|24px]] [[Sketcher Workbench/fr|Sketcher]], [[Image:Workbench_PartDesign.svg|24px]] [[PartDesign Workbench/fr|PartDesign]], etc.), sont basées sur ces fonctions exposées par l'atelier Part. Par conséquent, L'atelier Part est considéré comme le composant central des capacités de modélisation de FreeCAD.
 
 
Les objets créés avec l'atelier Part sont relativement simples. ils sont destinés à être utilisés avec des opérations booléennes (unions et coupes) afin de créer des formes plus complexes. Ce paradigme de modélisation est connu sous le nom de [CSG] [[constructive solid geometry]] et constitue la méthodologie traditionnelle utilisée dans les premiers systèmes de CAO. D'autre part, l'atelier [[PartDesign Workbench/fr|PartDesign]] fournit un flux de travail plus moderne pour la construction de formes: il utilise des croquis définis de manière paramétrique, qui sont extrudés pour former un corps solide de base, qui est ensuite modifié par des transformations paramétriques ([[feature editing/fr| édition de fonctions]]), jusqu'à l'obtention de l'objet final.
 
  
Les objets Part sont plus complexes que les objets maillés créés avec les [[Mesh Workbench/fr|Objets mailles]], les objets Part sont plus complexes et permettent donc des opérations plus avancées telles que les opérations booléennes cohérentes, l'historique des modifications et le comportement paramétrique.
+
Les objets créés avec l'atelier Part sont relativement simples. ils sont destinés à être utilisés avec des opérations booléennes (unions et coupes) afin de créer des formes plus complexes. '''Ce paradigme de modélisation est connu sous le nom de [CSG] [[constructive solid geometry/fr|constructive solid geometry]] et constitue la méthodologie traditionnelle utilisée dans les premiers systèmes de CAO'''. D'autre part, l'atelier [[PartDesign Workbench/fr|PartDesign]] fournit un flux de travail plus moderne pour la construction de formes: il utilise des croquis définis de manière paramétrique, qui sont extrudés pour former un corps solide de base, qui est ensuite modifié par des transformations paramétriques ([[feature editing/fr|édition de fonctions]]), jusqu'à l'obtention de l'objet final.
  
{{TOCright}}
+
Les objets Part sont plus complexes que les objets maillés créés avec [[Mesh Workbench/fr|l'atelier Mesh]], les objets Part sont plus complexes et permettent donc des opérations plus avancées telles que les opérations booléennes cohérentes, l'historique des modifications et le comportement paramétrique.
[[Image:Part example.jpg]]
 
  
 
[[Image:Part_Workbench_relationships.svg|600px]]
 
[[Image:Part_Workbench_relationships.svg|600px]]
Line 26: Line 28:
 
Ce sont des outils pour créer des objets primitifs.
 
Ce sont des outils pour créer des objets primitifs.
  
* [[Image:Part_Box.png|32px]] [[Part_Box/fr|Cube]]: Dessine un cube en spécifiant ses dimensions.
+
* [[Image:Part_Box.svg|32px]] [[Part_Box/fr|Cube]]: Dessine un cube en spécifiant ses dimensions.
* [[Image:Part_Cylinder.png|32px]] [[Part_Cylinder/fr|Cylindre]]: Dessine un cylindre en spécifiant ses dimensions.
+
* [[Image:Part_Cylinder.svg|32px]] [[Part_Cylinder/fr|Cylindre]]: Dessine un cylindre en spécifiant ses dimensions.
* [[Image:Part_Sphere.png|32px]] [[Part_Sphere/fr|Sphère]]: Dessine une sphère en spécifiant ses dimensions.
+
* [[Image:Part_Sphere.svg|32px]] [[Part_Sphere/fr|Sphère]]: Dessine une sphère en spécifiant ses dimensions.
* [[Image:Part_Cone.png|32px]] [[Part_Cone/fr|Cône]]: Dessine un cône en spécifiant ses dimensions.
+
* [[Image:Part_Cone.svg|32px]] [[Part_Cone/fr|Cône]]: Dessine un cône en spécifiant ses dimensions.
* [[Image:Part_Torus.png|32px]] [[Part_Torus/fr|Tore]]: Dessine un tore en spécifiant ses dimensions.
+
* [[Image:Part_Torus.svg|32px]] [[Part_Torus/fr|Tore]]: Dessine un tore en spécifiant ses dimensions.
* [[Image:Part_CreatePrimitives.png|32px]] [[Part_CreatePrimitives/fr|Création de Primitives]]: Un outil pour créer diverses primitives géométriques paramétriques.
+
* [[Image:Part_Primitives.svg|32px]] [[Part_Primitives/fr|Création de Primitives]]: Un outil pour ajouter l'une des primitives géométriques définies.
* [[Image:Part_Shapebuilder.png|32px]] [[Part_Shapebuilder/fr|Utilitaire de création de formes]]: Un outil avancé de création de formes plus complexes à partir de diverses primitives géométriques paramétriques.
+
* [[Image:Part_Shapebuilder.svg|32px]] [[Part_Shapebuilder/fr|Utilitaire de création de formes]]: Un outil avancé de création de formes plus complexes à partir de diverses primitives géométriques paramétriques.
  
 
===Modifier les objets===
 
===Modifier les objets===
Line 38: Line 40:
 
Voici les outils permettant de modifier les objets existants. Ils vous permettront de choisir quels objets modifier.
 
Voici les outils permettant de modifier les objets existants. Ils vous permettront de choisir quels objets modifier.
  
* [[Image:Part_Extrude.png|32px]] [[Part_Extrude/fr|Extrusion]]: Extrude les faces planes d'un objet
+
* [[Image:Part_Extrude.svg|32px]] [[Part_Extrude/fr|Extrusion]]: Extrude les faces planes d'un objet
* [[Image:Part_Revolve.png|32px]] [[Part_Revolve/fr|Révolution]]: Crée un solide en faisant tourner un autre objet (pas un solide) autour d'un axe
+
* [[Image:Part_Revolve.svg|32px]] [[Part_Revolve/fr|Révolution]]: Crée un solide en faisant tourner un autre objet (pas un solide) autour d'un axe
* [[Image:Part_Mirror.png|32px]] [[Part_Mirror/fr|Miroir]]: Reflète l'objet sélectionné sur un plan de miroir donné
+
* [[Image:Part_Mirror.svg|32px]] [[Part_Mirror/fr|Miroir]]: Reflète l'objet sélectionné sur un plan de miroir donné
* [[Image:Part_Fillet.png|32px]] [[Part_Fillet/fr|Congé]]: Congé (arrondi) le bords d'un objet
+
* [[Image:Part_Fillet.svg|32px]] [[Part_Fillet/fr|Congé]]: Congé (arrondi) le bords d'un objet
* [[Image:Part_Chamfer.png|32px]] [[Part_Chamfer/fr|Chanfrein]]: Chanfreine les bords d'un objet
+
* [[Image:Part_Chamfer.svg|32px]] [[Part_Chamfer/fr|Chanfrein]]: Chanfreine les bords d'un objet
* [[Image:Part_RuledSurface.png|32px]] [[Part_RuledSurface/fr|Création de surface]]: Crée une surface réglée
+
* [[Image:Part_RuledSurface.svg|32px]] [[Part_RuledSurface/fr|Création de surface]]: Crée une surface réglée
* [[Image:Part_Loft.png|32px]] [[Part_Loft/fr|Lissage]]: Crée une forme lissée d'un profil à un autre
+
* [[Image:Part_Loft.svg|32px]] [[Part_Loft/fr|Lissage]]: Crée une forme lissée d'un profil à un autre
* [[Image:Part_Sweep.png|32px]] [[Part_Sweep/fr|Balayage]]: Crée une forme en balayant un ou plusieurs profils le long d'un chemin
+
* [[Image:Part_Sweep.svg|32px]] [[Part_Sweep/fr|Balayage]]: Crée une forme en balayant un ou plusieurs profils le long d'un chemin
  
 
* [[Image:Part_CompOffsetTools.png|48px]] [[Part_CompOffsetTools/fr|Outils de décalage]]:
 
* [[Image:Part_CompOffsetTools.png|48px]] [[Part_CompOffsetTools/fr|Outils de décalage]]:
** [[Image:Part_Offset.png|32px]] [[Part_Offset/fr|Décalage 3D]]: Construit une forme parallèle à une certaine distance de l'original.
+
** [[Image:Part_Offset.svg|32px]] [[Part_Offset/fr|Décalage 3D]]: Construit une forme parallèle à une certaine distance de l'original.
** [[Image:Part_Offset2D.png|32px]] [[Part_Offset2D/fr|Décalage 2D]]: Construit un fil parallèle à une certaine distance de l'original ou agrandit/réduit une face plane. {{Version/fr|0.17}}
+
** [[Image:Part_Offset2D.svg|32px]] [[Part_Offset2D/fr|Décalage 2D]]: Construit un fil parallèle à une certaine distance de l'original ou agrandit/réduit une face plane. {{Version/fr|0.17}}
  
* [[Image:Part_Thickness.png|32px]] [[Part_Thickness/fr|Crée un évidement (coque)]]: Creuse un solide sur la (les) face(s) sélectionnée en laissant les autres parois à une épaisseur déterminée.
+
* [[Image:Part_Thickness.svg|32px]] [[Part_Thickness/fr|Crée un évidement (coque)]]: Creuse un solide sur la (les) face(s) sélectionnée en laissant les autres parois à une épaisseur déterminée.
  
 
* [[Image:Part_ProjectionOnSurface.png|32px]] [[Part_ProjectionOnSurface/fr|Projection sur une surface]]: Projetez un logo, un texte ou une face, un fil de fer, un bord à une surface. Avec Part Projection, il est possible de créer un solide ou un fil. {{Version/fr|0.19}}
 
* [[Image:Part_ProjectionOnSurface.png|32px]] [[Part_ProjectionOnSurface/fr|Projection sur une surface]]: Projetez un logo, un texte ou une face, un fil de fer, un bord à une surface. Avec Part Projection, il est possible de créer un solide ou un fil. {{Version/fr|0.19}}
  
* [[Image:Part_CompCompoundTools.png|48px]] [[Part_CompCompoundTools/fr|Outils pour Composés]]:
+
* [[Image:Part_Compound.svg|48px]] [[Part_CompCompoundTools/fr|Outils pour Composés]] :
** [[Image:Part MakeCompound.png|32px]] [[Part MakeCompound/fr|Créer un composé]]: Crée un composé à partir des objets sélectionnés.
+
** [[Image:Part_Compound.svg|32px]] [[Part_Compound/fr|Créer un composé]] : Crée un composé à partir des objets sélectionnés.
** [[Image: Part_ExplodeCompound.png|32px]] [[Part_ExplodeCompound/fr|Éclater le composé]]: Outil pour séparer les composés de formes.
+
** [[Image: Part_ExplodeCompound.png|32px]] [[Part_ExplodeCompound/fr|Éclater le composé]] : Outil pour séparer les composés de formes.
** [[Image:Part Compound‏‎Filter.png|32px]] [[Part Compound‏‎Filter/fr|Filtre un composé]]: Le CompoundFilter peut être utilisé pour extraire les morceaux individuels.
+
** [[Image:Part Compound‏‎Filter.svg|32px]] [[Part Compound‏‎Filter/fr|Filtre un composé]] : Le CompoundFilter peut être utilisé pour extraire les morceaux individuels.
  
* [[Image:Part_Booleans.png|32px]] [[Part_Booleans/fr|Opérations booléennes]]: Effectue des opérations booléennes sur des objets
+
* [[Image:Part_Booleans.svg|32px]] [[Part_Boolean/fr|Opération booléenne]] : Effectue des opérations booléennes sur des objets
* [[Image:Part_Union.png|32px]] [[Part_Union/fr|Union]]: Union de deux objets
+
* [[Image:Part_Fuse.svg|32px]] [[Part_Union/fr|Union]] : Union de deux objets
* [[Image:Part_Common.png|32px]] [[Part_Common/fr|Intersection]]: Extrait la partie commune (intersection) de deux objets
+
* [[Image:Part_Common.svg|32px]] [[Part_Common/fr|Intersection]] : Extrait la partie commune (intersection) de deux objets
* [[Image:Part_Cut.png|32px]] [[Part_Cut/fr|Soustraction]]: Coupe (soustrait) un objet d'un autre
+
* [[Image:Part_Cut.svg|32px]] [[Part_Cut/fr|Soustraction]] : Coupe (soustrait) un objet d'un autre
  
* [[Image:Part_CompJoinFeatures.png|48px]] [[Part CompJoinFeatures/fr|Joindre des objets à parois]]: fonctions booléennes intelligentes pour les objets à parois (par exemple, les tuyaux) {{Version/fr|0.16}}
+
* [[Image:Part_CompJoinFeatures.png|48px]] [[Part CompJoinFeatures/fr|Joindre des objets à parois]] : fonctions booléennes intelligentes pour les objets à parois (par exemple, les tuyaux) {{Version/fr|0.16}}
** [[Image:Part JoinConnect.png|32px]] [[Part_JoinConnect/fr|Connecter]]: Connecte l'extérieur et l'intérieur d'objets {{Version/fr|0.16}}
+
** [[Image:Part_JoinConnect.svg|32px]] [[Part_JoinConnect/fr|Connecter]] : Connecte l'extérieur et l'intérieur d'objets {{Version/fr|0.16}}
** [[Image:Part JoinEmbed.png|32px]] [[Part_JoinEmbed/fr|Intégrer]]: Intègre un objet à un autre objet {{Version/fr|0.16}}
+
** [[Image:Part_JoinEmbed.svg|32px]] [[Part_JoinEmbed/fr|Intégrer]] : Intègre un objet à un autre objet {{Version/fr|0.16}}
** [[Image:Part JoinCutout.png|32px]] [[Part_JoinCutout/fr|Découpe]]: Crée une découpe dans un objet en fonction d'un autre objet {{Version/fr|0.16}}
+
** [[Image:Part_JoinCutout.svg|32px]] [[Part_JoinCutout/fr|Découpe]] : Crée une découpe dans un objet en fonction d'un autre objet {{Version/fr|0.16}}
  
 
* [[Image:Part_CompSplittingTools.png|48px]] [[Part CompSplittingTools/fr|Outils de division de formes]]: {{Version/fr|0.17}}
 
* [[Image:Part_CompSplittingTools.png|48px]] [[Part CompSplittingTools/fr|Outils de division de formes]]: {{Version/fr|0.17}}
** [[Image:Part BooleanFragments.png|32px]] [[Part_BooleanFragments/fr|Fragments booléens]]: Crée toutes les pièces pouvant être obtenues par des opérations booléennes entre objets {{Version/fr|0.17}}
+
** [[Image:Part_BooleanFragments.svg|32px]] [[Part_BooleanFragments/fr|Fragments booléens]]: Crée toutes les pièces pouvant être obtenues par des opérations booléennes entre objets {{Version/fr|0.17}}
** [[Image: Part SliceApart.png|32px]] [[Part_SliceApart/fr|Trancher une pièce]]: outil pour diviser des formes par intersection avec d'autres formes
+
** [[Image:Part SliceApart.png|32px]] [[Part_SliceApart/fr|Trancher une pièce]]: outil pour diviser des formes par intersection avec d'autres formes
** [[Image:Part Slice.png|32px]] [[Part_Slice/fr|Scinder]]: Divise un objet en morceaux par intersection avec un autre objet {{Version/fr|0.17}}
+
** [[Image:Part_Slice.svg|32px]] [[Part_Slice/fr|Scinder]]: Divise un objet en morceaux par intersection avec un autre objet {{Version/fr|0.17}}
** [[Image:Part XOR.png|32px]] [[Part_XOR/fr|XOR]]: Supprime l'espace partagé (commun) par un nombre pair d'objets (version symétrique de [[Part_Cut/fr|Soustraction booléenne]]) {{Version/fr|0.17}}
+
** [[Image:Part_XOR.svg|32px]] [[Part_XOR/fr|XOR]]: Supprime l'espace partagé (commun) par un nombre pair d'objets (version symétrique de [[Part_Cut/fr|Soustraction booléenne]]) {{Version/fr|0.17}}
  
 
* [[Image:Part Defeaturing.svg|32px]] [[Part_Defeaturing/fr|Défaire une fonctionnalité]]: {{Version/fr|0.18}}
 
* [[Image:Part Defeaturing.svg|32px]] [[Part_Defeaturing/fr|Défaire une fonctionnalité]]: {{Version/fr|0.18}}
* [[Image:Part_Section.png|32px]] [[Part_Section/fr|Section]]: Crée une section en croisant un objet avec un plan de coupe
+
* [[Image:Part_Section.svg|32px]] [[Part_Section/fr|Section]]: Crée une section en croisant un objet avec un plan de coupe
* [[Image:Part_SectionCross.png|32px]] [[Part_SectionCross/fr|Multi Sections ...]]:
+
* [[Image:Part_CrossSections.svg|32px]] [[Part_SectionCross/fr|Multi Sections ...]] : Crée une ou plusieurs coupes transversales à travers une forme sélectionnée
 
* [[Image:Part Attachment.svg|32px]] [[Part Attachment/fr|Attachment]]: attachement est un utilitaire pour attacher un objet à un autre.
 
* [[Image:Part Attachment.svg|32px]] [[Part Attachment/fr|Attachment]]: attachement est un utilitaire pour attacher un objet à un autre.
  
Line 99: Line 101:
 
* [[File:Part_BoxSelection.svg|32px]] [[Part_BoxSelection/fr|BoxSelection]] : Ajoute à la sélection les faces des formes touchées par la sélection rectangulaire. {{Version/fr|0.19}}
 
* [[File:Part_BoxSelection.svg|32px]] [[Part_BoxSelection/fr|BoxSelection]] : Ajoute à la sélection les faces des formes touchées par la sélection rectangulaire. {{Version/fr|0.19}}
 
* [[Image:Part_ShapeFromMesh.svg|32px]] [[Part ShapeFromMesh/fr|Forme avec un Mesh]] : Crée un objet de forme à partir d'un objet de maillage.
 
* [[Image:Part_ShapeFromMesh.svg|32px]] [[Part ShapeFromMesh/fr|Forme avec un Mesh]] : Crée un objet de forme à partir d'un objet de maillage.
 +
* [[File:Part_PointsFromMesh.svg|32px]] [[Part PointsFromMesh/fr|Points du maillage]] : crée un objet de forme constitué de points du maillage. {{Version/fr|0.19}}
 
* [[Part_ConvertToSolid/fr|Conversion en solide]] : Convertit un objet solide forme en mesh objet.
 
* [[Part_ConvertToSolid/fr|Conversion en solide]] : Convertit un objet solide forme en mesh objet.
 
* [[Part_ReverseShapes/fr|Inverse L'objet]] : Inverse les normales de toutes les faces de l'objet sélectionné.
 
* [[Part_ReverseShapes/fr|Inverse L'objet]] : Inverse les normales de toutes les faces de l'objet sélectionné.
* [[File:Part_PointsFromMesh.svg|32px]] [[Part PointsFromMesh/fr|Points du maillage]] : crée un objet de forme constitué de points du maillage. {{Version/fr|0.19}}
 
* [[Image:Part CreateSimpleCopy‎.svg|32px]] [[Part CreateSimpleCopy/fr|Create simple copy]] : Crée une copie simple de l'objet sélectionné.
 
* [[Image:Part RefineShape.png|32px]] [[Part RefineShape/fr|Affine l'objet]] : Nettoie les faces en supprimant les lignes inutiles.
 
* [[Image:Part CheckGeometry.png|32px]] [[Part CheckGeometry/fr|Vérifie la géométrie]] : Vérifie les erreurs de la géométrie des objets sélectionnés.
 
* [[Image: Part Attachment.svg|32px]] [[Part Attachment/fr|Attachement]] : Attachement est un utilitaire permettant de joindre un objet à un autre.
 
  
 
* Créer une copie :
 
* Créer une copie :
Line 114: Line 112:
  
 
* [[Image:Part_CheckGeometry.svg|32px]] [[Part CheckGeometry/fr|Check geometry]]: Vérifie la géométrie des objets sélectionnés pour en détecter les erreurs.
 
* [[Image:Part_CheckGeometry.svg|32px]] [[Part CheckGeometry/fr|Check geometry]]: Vérifie la géométrie des objets sélectionnés pour en détecter les erreurs.
 +
 +
=== Outils de menu contextuel ===
 +
 +
* [[Std_SetAppearance/fr|Std Apparence]]: détermine l'apparence de la pièce entière (transparence des couleurs, etc.).
 +
* [[Std SetColors|Std Définir les couleurs]]: attribue des couleurs aux faces des pièces.
  
 
== Préférences ==
 
== Préférences ==
  
* [[Image:Preferences-import-export.svg|32px]] [[Import_Export_Preference/fr|Preference ...]] Import Export
+
<!-- Les préférences de PartDesign sont définies dans l'atelier Part et les deux ateliers PartDesign et Part les utilisent-->
 +
* [[Image:Preferences-part_design.svg|32px]] [[PartDesign_Preferences/fr|PartDesign Préférences]]: préférences disponibles pour les outils de Part (l'atelier Part utilise également les préférences PartDesign).
 +
* [[Image:Preferences-import-export.svg|32px]] [[Import_Export_Preference/fr|Préférences d'Import Export]]: préférences disponibles pour l'importation et l'exportation vers différents formats de fichier.
 +
* [[Fine-tuning/fr|Réglage fin]]: quelques paramètres supplémentaires pour affiner le comportement de la partie.
  
 
== OCCT concepts géométriques ==
 
== OCCT concepts géométriques ==
Line 123: Line 129:
 
Dans la terminologie OpenCascade, nous faisons la distinction entre les primitives géométriques et les formes (topologiques). Une primitive géométrique peut être un point, une ligne, un cercle, un plan, etc. ou même certains types plus complexes, comme une courbe B-Spline ou une surface. Une forme (shape en anglais) peut être un sommet, une arête, un fil, une face, un solide ou un composé d'autres formes. Les primitives géométriques ne sont pas faites pour être affichées directement sur la scène 3D, mais plutôt pour être utilisées comme géométrie de construction des formes. Par exemple, une arête peut être construite à partir d'une ligne ou d'une partie de cercle.
 
Dans la terminologie OpenCascade, nous faisons la distinction entre les primitives géométriques et les formes (topologiques). Une primitive géométrique peut être un point, une ligne, un cercle, un plan, etc. ou même certains types plus complexes, comme une courbe B-Spline ou une surface. Une forme (shape en anglais) peut être un sommet, une arête, un fil, une face, un solide ou un composé d'autres formes. Les primitives géométriques ne sont pas faites pour être affichées directement sur la scène 3D, mais plutôt pour être utilisées comme géométrie de construction des formes. Par exemple, une arête peut être construite à partir d'une ligne ou d'une partie de cercle.
  
Pour résumer, les primitives géométriques sont des blocs de construction "informes", et que les formes sont les véritables entités géométriques spatiales construites sur ces blocs.
+
Pour résumer, les primitives géométriques sont des blocs de construction "informes", tandis que les [[Part_TopoShape/fr|entités géométriques spatiales]]sont les véritables formes construites sur ces blocs.
 +
 
 +
Une liste complète de toutes les primitives et formes se réfère à la [http://www.opencascade.org/org/doc/ documentation OCC] (Alternative: [https://www.opencascade.com/doc/occt-7.4.0/refman/html/ sourcearchive.com]) et recherchez  '''Geom_*''' (pour les primitives géométriques) et '''TopoDS_*''' (pour les formes). Là, vous pouvez également en savoir plus sur les différences entre eux. Veuillez noter que la documentation officielle d'OCC n'est pas disponible en ligne (vous devez télécharger une archive) et s'adresse principalement aux programmeurs et non aux utilisateurs finaux. Mais j'espère que vous trouverez suffisamment d'informations pour commencer ici. Voir également [https://www.opencascade.com/doc/occt-7.0.0/overview/html/occt_user_guides__modeling_data.html Guide de l'utilisateur des données de modélisation].
 +
 
 +
<blockquote style="color: slategray">''À un niveau très élevé, la topologie indique de quelles pièces un objet est fait et les relations logiques entre elles. Une forme est constituée d'un certain ensemble de faces. Une face est délimitée par un certain ensemble d'arêtes. Deux faces sont adjacentes si elles partagent une arête commune.''</blockquote>
 +
 
 +
<blockquote style="color: slategray">''La topologie seule ne vous indique pas la taille, la courbure ou les emplacements 3D de ces pièces. Cependant, chaque élément de la topologie connaît sa géométrie sous-jacente. Une face sait sur quelle surface elle se trouve. Un bord sait sur quelle courbe il se trouve. La géométrie connaît la courbure et l'emplacement dans l'espace.'' - [https://www.opencascade.com/content/geometry-and-topology Source]</blockquote>
 +
 
 +
<hr />
 +
 
 +
<blockquote style="color: slategray">''Ainsi, la topologie définit la relation entre des entités géométriques simples qui peuvent être liées entre elles pour représenter des formes complexes.'' - [https://www.opencascade.com/doc/occt-7.0.0/overview/html/occt_user_guides__modeling_data.html Modeling Data User's Guide]</blockquote>
 +
 
 +
[[File:ClassTopoDS_Shape_inherit_graph.png]]
 +
 
 +
'''Remarque:''' Seuls 3 types d'objets topologiques ont des représentations géométriques - sommet, arête et face ([https://opencascade.blogspot.com/2009/02/topology-and-geometry-in-open- cascade.html Source]).
 +
 
 +
Les types géométriques peuvent en fait être divisés en deux groupes principaux: les courbes et les surfaces. A partir des courbes (ligne, cercle...) vous pouvez directement construire une arête, à partir des surfaces (plan, cylindre...) une face peut être construite. Par exemple, la ligne primitive géométrique est illimitée, c'est-à-dire qu'elle est définie par un vecteur de base et un vecteur de direction tandis que sa représentation de forme doit être quelque chose de limité par un point de départ et un point de fin. Et une boîte - un solide - peut être créée par six plans limités.
 +
 
 +
A partir d'une arête ou d'une face, on peut aussi revenir à son équivalent géométrique primitif.
  
Pour obtenir une liste complète de tous ces éléments, se référer à la [http://www.opencascade.org/org/doc/ documentation OCC] et rechercher Geom_Geometry et TopoDS_Shape. Là, vous pourrez également en savoir plus sur les différences entre les objets géométriques et les formes. À notre grand regret, la documentation OCC n'est malheureusement pas disponible en ligne (vous devez télécharger une archive) et est principalement destiné aux programmeurs et non aux utilisateurs finaux. Mais espérons que vous trouverez suffisamment d'informations pour commencer ici.
 
  
Les types géométriques peuvent en fait être divisés en deux groupes principaux: les courbes et les surfaces. Sur les courbes (ligne, cercle, ...) vous pouvez directement créer une arête, sur les surfaces (plan, cylindre, ...) une face peut être construite. Par exemple, la ligne primitive géométrique est illimitée, c'est à dire qu'elle est définie par un vecteur de base et un vecteur directeur tandis que la forme associée (et représentée) doit être quelque chose de limité par un début et de fin. Et un cube - un solide - peut être créée par six plans limités.
+
Ainsi, à partir de formes, vous pouvez créer des pièces très complexes ou, inversement, extraire toutes les sous-formes dont une forme plus complexe est constituée.
  
En contrepartie, il est également possible, depuis une arête ou une face, de revenir à sa primitive géométrique.
+
[[File:Part_TopoShape_relationships.svg|600px]]
  
Ainsi, en se basant sur les formes, vous pouvez construire des pièces très complexes ou, dans l'autre sens, extraire tous les sous-formes dont est faite une forme plus complexe.
+
{{Caption|La classe {{incode|Part::TopoShape}} est l'objet géométrique visible à l'écran. Essentiellement, tous les ateliers utilisent ces [[Part_TopoShape/fr|TopoShapes]] en interne pour créer et afficher des arêtes, des faces et des solides.}}
  
 
== Les scripts ==
 
== Les scripts ==
Line 142: Line 165:
 
L'objet le plus simple pouvant être créé est une [[Part Feature/fr|Part Feature]], qui possède une simple propriété {{PropertyData/fr|Placement}} et des propriétés de base permettant de définir sa couleur et son apparence.  
 
L'objet le plus simple pouvant être créé est une [[Part Feature/fr|Part Feature]], qui possède une simple propriété {{PropertyData/fr|Placement}} et des propriétés de base permettant de définir sa couleur et son apparence.  
  
Un autre objet simple utilisé dans les objets géométriques 2D est [[Part Part2DObject/fr|Part Part2DObject]], qui constitue la base des [[Sketcher Workbench/fr|esquisses]] et la plupart des [[Draft Workbench/fr|éléments Draft]].
+
Un autre objet simple utilisé dans les objets géométriques 2D est [[Part Part2DObject/fr|Part2DObject]], qui constitue la base des [[Sketcher_SketchObject/fr|objets esquisses]] ([[Sketcher Workbench/fr|esquisses]]) et la plupart des [[Draft Workbench/fr|éléments Draft]].
 +
 
 +
=== Script test ===
 +
 
 +
Testez la création de [[Part_Primitives/fr|primitives de pièce]] avec un script. {{Version|0.19}}
 +
 
 +
{{Code|code=
 +
import parttests.part_test_objects as pto
 +
pto.create_test_file("example_file")
 +
}}
 +
 
 +
Ce script se trouve dans le répertoire d'installation du programme et peut être examiné pour voir comment les primitives de base sont construites.
 +
{{Code|code=
 +
$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py
 +
}}
  
 
=== Exemples ===
 
=== Exemples ===
  
 
Pour créer un élément ligne, passer à la console Python et taper :
 
Pour créer un élément ligne, passer à la console Python et taper :
 +
 
{{Code|code=
 
{{Code|code=
 
import Part,PartGui  
 
import Part,PartGui  
Line 156: Line 194:
 
doc.recompute()
 
doc.recompute()
 
}}
 
}}
 +
 
Passons en revue l'exemple Python ci-dessus étape par étape :
 
Passons en revue l'exemple Python ci-dessus étape par étape :
 +
 
{{Code|code=
 
{{Code|code=
 
import Part,PartGui
 
import Part,PartGui
 
doc=App.newDocument()
 
doc=App.newDocument()
 
}}
 
}}
 +
 
charge l'atelier Pièce et crée un nouveau document
 
charge l'atelier Pièce et crée un nouveau document
 +
 
{{Code|code=
 
{{Code|code=
 
l=Part.LineSegment()
 
l=Part.LineSegment()
Line 167: Line 209:
 
l.EndPoint=(1.0,1.0,1.0)
 
l.EndPoint=(1.0,1.0,1.0)
 
}}
 
}}
 +
 
La fonction Line décrit en fait un segment de ligne, d'où le point de départ et le point final.
 
La fonction Line décrit en fait un segment de ligne, d'où le point de départ et le point final.
 +
 
{{Code|code=
 
{{Code|code=
 
doc.addObject("Part::Feature","Line").Shape=l.toShape()
 
doc.addObject("Part::Feature","Line").Shape=l.toShape()
 
}}
 
}}
 +
 
Cette commande ajoute un objet de type pièce au document et affecte la représentation de forme du segment de ligne à la propriété 'forme' ('Shape') de l'objet ajouté. Il est important de comprendre ici que nous avons utilisé une primitive géométrique (le Part.LineSegment) pour créer un TopoShape à partir de celle-ci (la méthode toShape()). Seules les formes peuvent être ajoutées au document. Dans FreeCAD, les primitives géométriques sont utilisées comme des "structures de base" pour construire les formes.
 
Cette commande ajoute un objet de type pièce au document et affecte la représentation de forme du segment de ligne à la propriété 'forme' ('Shape') de l'objet ajouté. Il est important de comprendre ici que nous avons utilisé une primitive géométrique (le Part.LineSegment) pour créer un TopoShape à partir de celle-ci (la méthode toShape()). Seules les formes peuvent être ajoutées au document. Dans FreeCAD, les primitives géométriques sont utilisées comme des "structures de base" pour construire les formes.
 +
 
{{Code|code=
 
{{Code|code=
 
doc.recompute()
 
doc.recompute()
 
}}
 
}}
 +
 
Mise à jour du document. Cela prépare également la représentation visuelle du nouvel objet pièce.
 
Mise à jour du document. Cela prépare également la représentation visuelle du nouvel objet pièce.
  
 
Notez qu'une Line Segment peut être créée en spécifiant son point de départ et son point final directement dans le constructeur, par ex. Part.LineSegment (point1, point2) ou nous pouvons créer une ligne par défaut et définir ses propriétés après, comme nous l'avons fait ici.
 
Notez qu'une Line Segment peut être créée en spécifiant son point de départ et son point final directement dans le constructeur, par ex. Part.LineSegment (point1, point2) ou nous pouvons créer une ligne par défaut et définir ses propriétés après, comme nous l'avons fait ici.
  
Un cercle peut être créé de la même manière:
+
Une ligne peut également être créée en utilisant :
 +
 
 +
{{Code|code=
 +
import FreeCAD
 +
import Part
 +
DOC = FreeCAD.newDocument()
 +
 
 +
def mycreateLine(pt1, pt2, objName):
 +
    obj = DOC.addObject("Part::Line", objName)
 +
    obj.X1 = pt1[0]
 +
    obj.Y1 = pt1[2]
 +
    obj.Z1 = pt1[2]
 +
 
 +
    obj.X2 = pt2[0]
 +
    obj.Y2 = pt2[1]
 +
    obj.Z2 = pt2[2]
 +
 
 +
    DOC.recompute()
 +
    return obj
 +
 
 +
line = mycreateLine((0,0,0), (0,10,0), "LineName")
 +
 
 +
}}
 +
 
 +
 
 +
 
 +
Un cercle peut être créé de la même manière :
 +
 
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
Line 189: Line 263:
 
doc.recompute()
 
doc.recompute()
 
}}
 
}}
 +
 +
ou en utilisant :
 +
 +
{{Code|code=
 +
import FreeCAD
 +
import Part
 +
DOC = FreeCAD.newDocument()
 +
 +
def mycreateCircle(rad, objName):
 +
    obj = DOC.addObject("Part::Circle", objName)
 +
    obj.Radius = rad
 +
 +
    DOC.recompute()
 +
    return obj
 +
 +
circle = mycreateCircle(5.0, "CircleName")
 +
 +
}}
 +
 +
 
Notez qu'une fois encore, nous avons utilisé le cercle (primitive géométrique) pour construire une forme. Nous pouvons bien sûr toujours accéder à notre géométrie de construction par la suite, en faisant:
 
Notez qu'une fois encore, nous avons utilisé le cercle (primitive géométrique) pour construire une forme. Nous pouvons bien sûr toujours accéder à notre géométrie de construction par la suite, en faisant:
 +
 
{{Code|code=
 
{{Code|code=
 
s = f.Shape
 
s = f.Shape
Line 195: Line 290:
 
c = e.Curve
 
c = e.Curve
 
}}
 
}}
 +
 
Ici on prend la forme de notre objet f, puis nous prenons la liste de ses arêtes. Dans ce cas il y aura une seule arête parce que nous avons fait toute la forme à partir d'un cercle unique, c'est pourquoi nous ne prenons que le premier élément de la liste des arêtes, et puis nous récupérons sa courbe. Chaque arête a une courbe, qui est la géométrie primitive, sur laquelle elle est basée.
 
Ici on prend la forme de notre objet f, puis nous prenons la liste de ses arêtes. Dans ce cas il y aura une seule arête parce que nous avons fait toute la forme à partir d'un cercle unique, c'est pourquoi nous ne prenons que le premier élément de la liste des arêtes, et puis nous récupérons sa courbe. Chaque arête a une courbe, qui est la géométrie primitive, sur laquelle elle est basée.
  
Line 204: Line 300:
 
* [[Whiffle_Ball_tutorial/fr|Tutoriel balle Whiffle]] : Comment utiliser l'atelier Part
 
* [[Whiffle_Ball_tutorial/fr|Tutoriel balle Whiffle]] : Comment utiliser l'atelier Part
  
{{docnav/fr|[[OpenSCAD Module/fr|Atelier OpenSCAD]]|[[PartDesign Workbench/fr|Atelier PartDesign]]|IconL=OpenSCADWorkbench.svg|IconR=Workbench_PartDesign.svg}}
+
{{Docnav/fr
 +
|[[OpenSCAD Module/fr|Module OpenSCAD]]
 +
|[[PartDesign Workbench/fr|Atelier PartDesign]]
 +
|IconL=Workbench_OpenSCAD.svg
 +
|IconR=Workbench_PartDesign.svg
 +
}}
  
{{Userdocnavi/fr}}
+
{{Part Tools navi{{#translation:}}}}
[[Category:Part/fr]]
+
{{Userdocnavi{{#translation:}}}}
[[Category:Workbenches/fr]]
+
[[Category:Workbenches{{#translation:}}]]

Latest revision as of 18:23, 6 August 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎hrvatski • ‎italiano • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎svenska • ‎čeština • ‎русский • ‎українська • ‎中文 • ‎中文(中国大陆)‎ • ‎中文(台灣)‎ • ‎日本語
Arrow-left.svg Page précédente : Workbench OpenSCAD.svg Module OpenSCAD
Page suivante : Atelier PartDesign Workbench PartDesign.svg Arrow-right.svg
Icône de l'Atelier Part

Introduction

Les capacités de modélisations de solides de FreeCAD sont basées sur le noyau OpenCASCADE Technology (OCCT), un système de CAO de niveau professionnel qui offre une création et une manipulation avancées de la géométrie 3D. L'Workbench Part.svg atelier Part est une couche située au-dessus des bibliothèques OCCT qui permet à l'utilisateur d'accéder aux primitives et fonctions géométriques OCCT. Toutes les fonctions de dessin 2D et 3D de chaque atelier (Workbench Draft.svg Draft, Workbench Sketcher.svg Sketcher, Workbench PartDesign.svg PartDesign, etc.), sont basées sur ces fonctions exposées par l'atelier Part. Par conséquent, L'atelier Part est considéré comme le composant central des capacités de modélisation de FreeCAD.

Les objets créés avec l'atelier Part sont relativement simples. ils sont destinés à être utilisés avec des opérations booléennes (unions et coupes) afin de créer des formes plus complexes. Ce paradigme de modélisation est connu sous le nom de [CSG] constructive solid geometry et constitue la méthodologie traditionnelle utilisée dans les premiers systèmes de CAO. D'autre part, l'atelier PartDesign fournit un flux de travail plus moderne pour la construction de formes: il utilise des croquis définis de manière paramétrique, qui sont extrudés pour former un corps solide de base, qui est ensuite modifié par des transformations paramétriques (édition de fonctions), jusqu'à l'obtention de l'objet final.

Les objets Part sont plus complexes que les objets maillés créés avec l'atelier Mesh, les objets Part sont plus complexes et permettent donc des opérations plus avancées telles que les opérations booléennes cohérentes, l'historique des modifications et le comportement paramétrique.

Part Workbench relationships.svg

L'atelier Part est la couche de base qui expose les fonctions de dessin OCCT à tous les ateliers de FreeCAD.


Les outils

Les outils de l'atelier Part sont situés dans le menu Part qui apparaît lorsque l'on charge l'atelier Part.

Primitives

Ce sont des outils pour créer des objets primitifs.

  • Part Box.svg Cube: Dessine un cube en spécifiant ses dimensions.
  • Part Cylinder.svg Cylindre: Dessine un cylindre en spécifiant ses dimensions.
  • Part Sphere.svg Sphère: Dessine une sphère en spécifiant ses dimensions.
  • Part Cone.svg Cône: Dessine un cône en spécifiant ses dimensions.
  • Part Torus.svg Tore: Dessine un tore en spécifiant ses dimensions.
  • Part Primitives.svg Création de Primitives: Un outil pour ajouter l'une des primitives géométriques définies.
  • Part Shapebuilder.svg Utilitaire de création de formes: Un outil avancé de création de formes plus complexes à partir de diverses primitives géométriques paramétriques.

Modifier les objets

Voici les outils permettant de modifier les objets existants. Ils vous permettront de choisir quels objets modifier.

  • Part Extrude.svg Extrusion: Extrude les faces planes d'un objet
  • Part Revolve.svg Révolution: Crée un solide en faisant tourner un autre objet (pas un solide) autour d'un axe
  • Part Mirror.svg Miroir: Reflète l'objet sélectionné sur un plan de miroir donné
  • Part Fillet.svg Congé: Congé (arrondi) le bords d'un objet
  • Part Chamfer.svg Chanfrein: Chanfreine les bords d'un objet
  • Part RuledSurface.svg Création de surface: Crée une surface réglée
  • Part Loft.svg Lissage: Crée une forme lissée d'un profil à un autre
  • Part Sweep.svg Balayage: Crée une forme en balayant un ou plusieurs profils le long d'un chemin
  • Part Thickness.svg Crée un évidement (coque): Creuse un solide sur la (les) face(s) sélectionnée en laissant les autres parois à une épaisseur déterminée.

Mesure

Std Measure Menu.png Mesure: Permet des mesures linéaires et angulaires entre les points, les arêtes et les faces.

Autres outils

  • Part CheckGeometry.svg Check geometry: Vérifie la géométrie des objets sélectionnés pour en détecter les erreurs.

Outils de menu contextuel

Préférences

  • Preferences-part design.svg PartDesign Préférences: préférences disponibles pour les outils de Part (l'atelier Part utilise également les préférences PartDesign).
  • Preferences-import-export.svg Préférences d'Import Export: préférences disponibles pour l'importation et l'exportation vers différents formats de fichier.
  • Réglage fin: quelques paramètres supplémentaires pour affiner le comportement de la partie.

OCCT concepts géométriques

Dans la terminologie OpenCascade, nous faisons la distinction entre les primitives géométriques et les formes (topologiques). Une primitive géométrique peut être un point, une ligne, un cercle, un plan, etc. ou même certains types plus complexes, comme une courbe B-Spline ou une surface. Une forme (shape en anglais) peut être un sommet, une arête, un fil, une face, un solide ou un composé d'autres formes. Les primitives géométriques ne sont pas faites pour être affichées directement sur la scène 3D, mais plutôt pour être utilisées comme géométrie de construction des formes. Par exemple, une arête peut être construite à partir d'une ligne ou d'une partie de cercle.

Pour résumer, les primitives géométriques sont des blocs de construction "informes", tandis que les entités géométriques spatialessont les véritables formes construites sur ces blocs.

Une liste complète de toutes les primitives et formes se réfère à la documentation OCC (Alternative: sourcearchive.com) et recherchez Geom_* (pour les primitives géométriques) et TopoDS_* (pour les formes). Là, vous pouvez également en savoir plus sur les différences entre eux. Veuillez noter que la documentation officielle d'OCC n'est pas disponible en ligne (vous devez télécharger une archive) et s'adresse principalement aux programmeurs et non aux utilisateurs finaux. Mais j'espère que vous trouverez suffisamment d'informations pour commencer ici. Voir également Guide de l'utilisateur des données de modélisation.

À un niveau très élevé, la topologie indique de quelles pièces un objet est fait et les relations logiques entre elles. Une forme est constituée d'un certain ensemble de faces. Une face est délimitée par un certain ensemble d'arêtes. Deux faces sont adjacentes si elles partagent une arête commune.

La topologie seule ne vous indique pas la taille, la courbure ou les emplacements 3D de ces pièces. Cependant, chaque élément de la topologie connaît sa géométrie sous-jacente. Une face sait sur quelle surface elle se trouve. Un bord sait sur quelle courbe il se trouve. La géométrie connaît la courbure et l'emplacement dans l'espace. - Source


Ainsi, la topologie définit la relation entre des entités géométriques simples qui peuvent être liées entre elles pour représenter des formes complexes. - Modeling Data User's Guide

ClassTopoDS Shape inherit graph.png

Remarque: Seuls 3 types d'objets topologiques ont des représentations géométriques - sommet, arête et face (cascade.html Source).

Les types géométriques peuvent en fait être divisés en deux groupes principaux: les courbes et les surfaces. A partir des courbes (ligne, cercle...) vous pouvez directement construire une arête, à partir des surfaces (plan, cylindre...) une face peut être construite. Par exemple, la ligne primitive géométrique est illimitée, c'est-à-dire qu'elle est définie par un vecteur de base et un vecteur de direction tandis que sa représentation de forme doit être quelque chose de limité par un point de départ et un point de fin. Et une boîte - un solide - peut être créée par six plans limités.

A partir d'une arête ou d'une face, on peut aussi revenir à son équivalent géométrique primitif.


Ainsi, à partir de formes, vous pouvez créer des pièces très complexes ou, inversement, extraire toutes les sous-formes dont une forme plus complexe est constituée.

Part TopoShape relationships.svg

La classe Part::TopoShape est l'objet géométrique visible à l'écran. Essentiellement, tous les ateliers utilisent ces TopoShapes en interne pour créer et afficher des arêtes, des faces et des solides.


Les scripts

Voir aussi: Part scripts

La structure principale de données utilisée dans l'atelier Pièce est le type de données BRep d'OpenCascade. Presque tous les contenus et les types d'objets de l'atelier Pièce sont maintenant disponibles pour les scripts Python. Cela inclut les primitives géométriques, telles que les lignes (Line) et les cercles (Circle ou Arc), et l'ensemble des TopoShapes, tels que les vertex, arêtes, fils, faces, solides et composés. Pour chacun de ces objets, plusieurs méthodes de création existent, et pour certains d'entre eux, en particulier les TopoShapes, des opérations avancées telles que les opérations booléennes union / soustraction / intersection sont également disponibles. Explorez le contenu de l'atelier Pièce, tel que décrit dans la page Les bases du langage de script de FreeCAD, pour en savoir plus.

L'objet le plus simple pouvant être créé est une Part Feature, qui possède une simple propriété DonnéesPlacement et des propriétés de base permettant de définir sa couleur et son apparence.

Un autre objet simple utilisé dans les objets géométriques 2D est Part2DObject, qui constitue la base des objets esquisses (esquisses) et la plupart des éléments Draft.

Script test

Testez la création de primitives de pièce avec un script. introduced in version 0.19

import parttests.part_test_objects as pto
pto.create_test_file("example_file")

Ce script se trouve dans le répertoire d'installation du programme et peut être examiné pour voir comment les primitives de base sont construites.

$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py

Exemples

Pour créer un élément ligne, passer à la console Python et taper :

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Passons en revue l'exemple Python ci-dessus étape par étape :

import Part,PartGui
doc=App.newDocument()

charge l'atelier Pièce et crée un nouveau document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

La fonction Line décrit en fait un segment de ligne, d'où le point de départ et le point final.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

Cette commande ajoute un objet de type pièce au document et affecte la représentation de forme du segment de ligne à la propriété 'forme' ('Shape') de l'objet ajouté. Il est important de comprendre ici que nous avons utilisé une primitive géométrique (le Part.LineSegment) pour créer un TopoShape à partir de celle-ci (la méthode toShape()). Seules les formes peuvent être ajoutées au document. Dans FreeCAD, les primitives géométriques sont utilisées comme des "structures de base" pour construire les formes.

doc.recompute()

Mise à jour du document. Cela prépare également la représentation visuelle du nouvel objet pièce.

Notez qu'une Line Segment peut être créée en spécifiant son point de départ et son point final directement dans le constructeur, par ex. Part.LineSegment (point1, point2) ou nous pouvons créer une ligne par défaut et définir ses propriétés après, comme nous l'avons fait ici.

Une ligne peut également être créée en utilisant :

import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateLine(pt1, pt2, objName):
    obj = DOC.addObject("Part::Line", objName)
    obj.X1 = pt1[0]
    obj.Y1 = pt1[2]
    obj.Z1 = pt1[2]

    obj.X2 = pt2[0]
    obj.Y2 = pt2[1]
    obj.Z2 = pt2[2]

    DOC.recompute()
    return obj

line = mycreateLine((0,0,0), (0,10,0), "LineName")


Un cercle peut être créé de la même manière :

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

ou en utilisant :

import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateCircle(rad, objName):
    obj = DOC.addObject("Part::Circle", objName)
    obj.Radius = rad

    DOC.recompute()
    return obj

circle = mycreateCircle(5.0, "CircleName")


Notez qu'une fois encore, nous avons utilisé le cercle (primitive géométrique) pour construire une forme. Nous pouvons bien sûr toujours accéder à notre géométrie de construction par la suite, en faisant:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Ici on prend la forme de notre objet f, puis nous prenons la liste de ses arêtes. Dans ce cas il y aura une seule arête parce que nous avons fait toute la forme à partir d'un cercle unique, c'est pourquoi nous ne prenons que le premier élément de la liste des arêtes, et puis nous récupérons sa courbe. Chaque arête a une courbe, qui est la géométrie primitive, sur laquelle elle est basée.

Rendez-vous sur la page Les scripts de pièces si vous voulez en savoir plus.

Tutoriels

Arrow-left.svg Page précédente : Workbench OpenSCAD.svg Module OpenSCAD
Page suivante : Atelier PartDesign Workbench PartDesign.svg Arrow-right.svg